<template>
  <div class="tiny-hamburger" :class="{ 'has-unread-message': isHasUnreadMessage }">
    <el-menu
      :ellipsis="false"
      :default-active="activeTab"
      menu-trigger="click"
      class="w-full border-0 el-menu-demo"
      mode="horizontal"
      text-color="var(--text)"
      active-text-color="var(--secondary)"
      background-color="transparent"
      style="width: 48px; height: 40px"
    >
      <el-sub-menu index="1" class="tiny-m-user-center">
        <template #title>
          <div
            class="flex items-center justify-center tiny-button"
            :class="{ 'tiny-button-rotate': isTinyUserCenterEnabled }"
            @click="tiggerTinyUserCenter"
          >
            <div class="w-[12.67px] flex place-content-between">
              <div v-for="item in 3" :key="item" class="tiny-dot"></div>
            </div>
          </div>
        </template>
        <div class="py-2 mx-auto overflow-none overflow-scroll hamburger-sub-menu" :class="{ 'hamburger-sub-unauth':!auth }">
          <div class="flex flex-col items-center gap-2">
            <div
              v-if="menuTabHeaders.length > 0"
              class="flex flex-col items-start w-full p-0"
              :class="!auth ? 'user-center-blur relative' : ''"
            >
              <div v-if="!auth" class="absolute top-[50%] left-[50%] translate-x-[-50%] translate-y-[-50%] w-[208px] text-center flex justify-center flex-wrap">
                <img :src="getAssetImage('assets/common/user-center-unauth.png')" class="mb-4" />
                <span>{{ $t("Please login before using Usercenter") }}</span>
              </div>
              <new-black-theme-sidebar-menu
                v-for="menu in userCenterMenuTab"
                :key="menu"
                :menu="menu"
                :is-new-menu="true"
                :is-use-tab-language="true"
                class="user-center-menu-tab relative tiny-m-user-center px-4"
                :class="{ 'blur-sm': !auth }"
              />
            </div>
            <div
              v-if="isAllowPromotionTab"
              class="border border-solid border-[color:var(--border)] opacity-50 w-full"
            ></div>
            <div
              v-if="isAllowPromotionTab"
              class="flex flex-row items-center justify-between w-full gap-8 py-3 h-11"
            >
              <nuxt-link to="/Promotion" class="w-full" @click="toggleSidebar">
                <div
                  class="flex flex-row justify-between items-center py-3 gap-[39px] h-11 w-full relative"
                >
                  <div class="flex flex-row items-center h-5 gap-2 p-0">
                    <div class="w-5 h-5">
                      <svg-icon
                        svg-name="icon-promotion-2"
                        class="icon w-[17px] h-[17px]"
                      />
                    </div>
                    <span class="uppercase sidebar-text">{{
                      $t("promotion")
                    }}</span>
                  </div>
                  <div class="flex items-center m-angle-right-container">
                    <font-awesome-icon
                      icon="angle-right"
                      class="icon-angle-right"
                    />
                  </div>
                </div>
              </nuxt-link>
            </div>
            <div
              class="border border-solid border-[color:var(--border)] opacity-50 w-full"
            ></div>
            <!-- <div
              v-if="!agentCooperation.IsHidden"
              class="flex flex-row justify-between items-center py-3 gap-[39px] h-11 w-full mb-[-0.5rem] cursor-pointer"
              @click="toggleAgentCooperation"
            >
              <div class="flex flex-row items-center h-5 gap-2 p-0">
                <div class="w-5 h-5">
                  <svg-icon
                    svg-name="icon-people"
                    class="object-contain w-full h-full"
                  />
                </div>
                <span class="sidebar-text">{{ $t("agent_cooperation") }}</span>
              </div>
              <div class="flex items-center m-angle-right-container">
                <font-awesome-icon icon="angle-right" />
              </div>
            </div> -->
            <div
              class="flex flex-col w-full rounded-lg px-4"
            >
              <el-collapse>
                <el-collapse-item>
                  <template #title>
                    <div class="flex items-center justify-between w-full">
                      <div class="flex items-center fc-text">
                        <div class="icon-lang">
                          <img
                            :src="
                              getAssetImage(
                                `assets/materials/languageIcon/${defaultLanguage}.svg`
                              )
                            "
                          />
                        </div>
                        <span class="profile-menu-title">{{
                          defaultLanguageForDisplay
                        }}</span>
                      </div>
                      <div class="flex items-center m-angle-right-container">
                        <font-awesome-icon
                          icon="angle-down"
                          class="m-language-collapse"
                        />
                      </div>
                    </div>
                  </template>
                  <div>
                    <div
                      v-for="(lang, index) in languages"
                      :key="`lang-${index}`"
                    >
                      <div
                        class="flex items-center cursor-pointer padding-y fc-text"
                        @click="switchLanguage(lang.ISO)"
                      >
                        <div class="icon-lang">
                          <img
                            :src="
                              getAssetImage(
                                `assets/materials/languageIcon/${lang.ISO}.svg`
                              )
                            "
                          />
                        </div>
                        <div class="profile-menu-title">
                          {{ lang.LanguageLocalName }}
                        </div>
                      </div>
                    </div>
                  </div>
                </el-collapse-item>
              </el-collapse>
            </div>
            <div
              v-if="auth"
              class="border border-solid border-[color:var(--border)] opacity-50 w-full"
            ></div>
            <div v-if="auth" class="w-full my-4 px-4">
                <div class="m-profile-menu-item" @click="onLogout">
                <div class="flex justify-between">
                  <div class="flex items-center fc-text">
                    <svg-icon
                      svg-name="icon-signout"
                      class="icon w-[21px] h-[21px]"
                    />
                    <!-- <img :src="getAssetImage('assets/theme/new_black_theme/SignOut.svg')" class="m-0 w-[24px] h-[24px]"> -->
                    <span class="profile-menu-title">{{ $t("logout") }}</span>
                  </div>
                  <div class="flex items-center m-angle-right-container">
                    <font-awesome-icon icon="angle-right" />
                  </div>
                </div>
              </div>
            </div>
          </div>
          <template v-if="isAppDownloadEnabled">
            <a v-if="appDownloadURL === ''" :href="appUrl" download>
              <div
                class="absolute bottom-0 right-0 rounded-t-2xl bg-theme-color"
              >
                <div
                  class="flex flex-row items-end justify-between h-16 gap-1 px-1"
                >
                  <div class="w-[68px] h-[68px]">
                    <img
                      :src="
                        getAssetImage(
                          'assets/theme/new_black_theme/app_download.png'
                        )
                      "
                      alt=""
                    />
                  </div>
                  <div class="flex flex-row items-center p-0 gap-1 h-16 z-[1]">
                    <div
                      class="flex flex-col justify-center items-start p-0 h-16 w-[98px]"
                    >
                      <span class="app-download-title"
                        >{{ brandName }} APP</span
                      >
                      <span class="app-download-content"
                        >Download <br />
                        our Android APP</span
                      >
                    </div>
                    <div class="w-[78px] h-[30px]">
                      <el-button
                        :type="theme == 'bk8' ? 'primary' : 'danger'"
                        round
                        class="capitalize bk8-downloadBtn"
                        >{{ $t("download") }}</el-button
                      >
                    </div>
                  </div>
                </div>
                <div
                  class="bg-app-download"
                  :style="`background-image: ${bgApp};`"
                ></div>
              </div>
            </a>
            <a
              v-else
              :href="
                appDownloadURL.includes('://')
                  ? appDownloadURL
                  : `//${appDownloadURL}`
              "
              target="_blank"
            >
              <div
                class="absolute bottom-0 right-0 rounded-t-2xl bg-theme-color"
              >
                <div
                  class="flex flex-row items-end justify-between h-16 gap-1 px-1"
                >
                  <div class="w-[68px] h-[68px]">
                    <img
                      :src="
                        getAssetImage(
                          'assets/theme/new_black_theme/app_download.png'
                        )
                      "
                      alt=""
                    />
                  </div>
                  <div class="flex flex-row items-center p-0 gap-1 h-16 z-[1]">
                    <div
                      class="flex flex-col justify-center items-start p-0 h-16 w-[98px]"
                    >
                      <span class="app-download-title"
                        >{{ brandName }} APP</span
                      >
                      <span class="app-download-content"
                        >Download <br />
                        our Android APP</span
                      >
                    </div>
                    <div class="w-[78px] h-[30px]">
                      <el-button
                        :type="theme == 'bk8' ? 'primary' : 'danger'"
                        round
                        class="capitalize bk8-downloadBtn"
                        >{{ $t("download") }}</el-button
                      >
                    </div>
                  </div>
                </div>
                <div
                  class="bg-app-download"
                  :style="`background-image: ${bgApp};`"
                ></div>
              </div>
            </a>
          </template>
        </div>
      </el-sub-menu>
    </el-menu>
  </div>
</template>

<script setup lang="ts">
import useMenu from "@/composables/useMenu";
import {
  useHeaderComponent,
  useLanguageComponent,
} from "@/composables/useTheme";
import { store } from "~/store";
import { IGame, TabInfo } from "@/models/IGetPlayableGamesResponse";
import { memberMessageStore } from "~~/store/member-message";

const { getAssetImage } = commonHelper;
const route = useRoute();
const isShowReferralPage = computed(() => store.state.IsShowReferralPage);
const {
  auth,
  isReferralV2Enabled,
  agentCooperation,
  logout,
  isAppDownloadEnabled,
  appUrl,
  appDownloadURL,
} = useHeaderComponent();
const { fetchMessages } = useMessage();
const isHasUnreadMessage = computed(() => {
  return memberMessageStore.getters.isHasUnreadMessage;
});
const {
  isCashPlayer,
  isShowDepositWithdrawal,
  isShowPromotion,
  isShowReferral,
} = useMenu();
const {
  languages,
  defaultLanguage,
  switchLanguage,
  defaultLanguageForDisplay,
} = useLanguageComponent();
const tabs = reactive([
  {
    to: "/deposit",
    label: "deposit",
    icon: "icon-deposit",
    display: isCashPlayer.value && isShowDepositWithdrawal.value,
  },
  {
    to: "/withdrawal",
    label: "withdrawal",
    icon: "icon-withdraw",
    display: isCashPlayer.value && isShowDepositWithdrawal.value,
  },
  { to: "/wallet", label: "wallet", icon: "icon-wallet", display: true },
  { to: "/account", label: "account", icon: "icon-account", display: true },
  {
    to: "/transaction-history",
    label: "statement",
    icon: "icon-transaction",
    display: true,
  },
  {
    to: "/bet-history",
    label: "bet_history",
    icon: "icon-bethistory",
    display: true,
  },
  {
    to: "/my-promotion",
    label: "promotion",
    icon: "icon-promotion",
    display: isShowPromotion.value,
  },
  {
    to: "/referral",
    label: "referral",
    icon: "icon-referral",
    display:
      isCashPlayer.value &&
      isShowReferral.value &&
      !isReferralV2Enabled.value &&
      isShowReferralPage.value,
  },
  {
    to: "/referral-v2",
    label: "referral",
    icon: "icon-referral",
    display: isReferralV2Enabled.value && isShowReferralPage.value,
  },
  {
    to: "/help-center",
    label: "help_center",
    icon: "icon-aboutus",
    display: true,
  },
  {
    to: "/messages",
    label: "messages",
    icon: "icon-message",
    display: true,
  },
]).filter((p) => p.display);
const userCenterMenuTab: TabInfo[] = tabs.map((item, index) => {
  return {
    IsFilter: false,
    Order: index + 1,
    TabURL: item.to,
    TabType: item.label,
    TabLanguage: item.icon,
  };
});
const isTinyUserCenterEnabled = ref(false);
const tiggerTinyUserCenter = () => {
  isTinyUserCenterEnabled.value = !isTinyUserCenterEnabled.value;
};
onMounted(() => {
  if (!route.fullPath.includes("messages")) {
    fetchMessages();
  }
});
const onLogout = () => {
  logout();
};
</script>
<style lang="scss">
.tiny-button {
  width: 24px;
  height: 24px;
  background-color: var(--background5);
  border-radius: 50%;
  rotate: 90deg;
  cursor: pointer;
  transition: rotate 0.3s;
  position: relative;
  z-index: 99;
}
.tiny-button-rotate {
  rotate: 0deg;
}
.tiny-dot {
  width: 2px;
  height: 2px;
  border-radius: 50%;
  background-color: var(--text5);
}
.tiny-hamburger {
  position: relative;
  .el-menu-demo {
    border: none;
    .el-sub-menu.is-active {
      .el-sub-menu__title {
        --secondary: transparent;
      }
    }
  }
  .el-tooltip__trigger .el-icon {
    display: none;
  }
}
.hamburger-sub-menu {
  width: 240px;
}
.el-menu--popup:has(.hamburger-sub-unauth) {
  padding-top: 0px;
}
.el-menu--popup:has(.hamburger-sub-menu) {
  background-color: var(--background5);
  a .m-angle-right-container {
    display: none;
  }
  .el-collapse-item__header {
    background: var(--background5);
  }
  .el-collapse {
    border: none;
    .el-collapse-item__content {
        background: var(--background5);
        padding-bottom: 0;
    }
  }
  .router-link-exact-active svg {
    fill: var(--primary);
  }
}
.el-popper:has(.tiny-m-user-center) {
  border: none;
}
.user-center-blur::before {
  content: "";
  position: absolute;
  top: -8px;
  left: 0;
  width: 100%;
  height: calc(100% + 16px);
  background: rgba(0, 0, 0, 0.5);
}
.has-unread-message::before {
  content: "";
  position: absolute;
  top: 7px;
  right: 4px;
  width: 6px;
  height: 6px;
  border-radius: 50%;
  background: var(--failure);
  z-index: 100;
}
</style>
